package sax.mixed;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class AuthorFindHandler extends DefaultHandler {

    boolean documentJustOpened;
    String topLevelAuthorValue;
    int commonAuthorValueCount;

    @Override
    public void startDocument() throws SAXException {
        documentJustOpened = true; //Initialization
        commonAuthorValueCount = 0;
    }

    @Override
    public void startElement(String uri, String localName, String qName,
            Attributes attributes) throws SAXException {
        if (documentJustOpened) {
            topLevelAuthorValue = attributes.getValue("author");
            documentJustOpened = false;
            System.out.println("Top Author=" + topLevelAuthorValue);
        } else {
            final String authorValue = attributes.getValue("author");
            if (null != authorValue && authorValue.equals(topLevelAuthorValue)) {
                commonAuthorValueCount++;
            }
        }
    }

    public String getTopLevelAuthorValue() { return topLevelAuthorValue;}

    public int getCommonAuthorValueCount() { return commonAuthorValueCount;}
}