package de.hdm_stuttgart.mi.sd1.statistics.main;

/**
 * Possible application error states providing both
 * error code values and corresponding messages.
 *
 */
public enum ErrorState {

  /**
   * Our normal exit value in case the user's input is correct.
   */
  OK(0), 
  
  /**
   * The user did not supply any value at all
   */
  NO_VALUE(-1),
  
  /**
   * At least on argument supplied by the user does not represent
   * an integer value.
   */
  NO_INTEGER(-2);
  
  ErrorState(final int errorCode) {
    this.errorCode = errorCode;
  }
  /**
   * The current state's error code
   */
  public final int errorCode;
  
}
