package de.hdm_stuttgart.mi.sd1.statistics.main;

import de.hdm_stuttgart.mi.sd1.statistics.IntegerStore;

/**
 * An application calculating statistical information
 * for data being provided as command line arguments. 
 *
 */
public class Statistics {
  /**
   * Calculate average and median of a given sample's integer values.
   * 
   * @param args Multiple integer values defining a series of measurements. 
   */
  public static void main(String[] args) {

    final InputValidator userInput = new InputValidator(args);
    
    final IntegerStore store = new IntegerStore(userInput.values);
    System.out.println("Your sample's average is: " + store.getAverage());
    System.out.println("Your sample's median is: " + store.getMedian());
  }
}
