package de.hdm_stuttgart.mi.sd1.intmax;

import org.junit.Assert;
import org.junit.Test;

/**
 * Unit test array max values.
 */
@SuppressWarnings("javadoc")
public class AppTest {
  
  @Test
  public void testSingleValue() {
    final int[] v = {-3};
    Assert.assertEquals(0, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {0}, Max.getMaxIndexValues(v));
  }
  
  @Test
  public void testUniqueValues() {
    final int[] v = {-3, 4, 100, 7, 11, 20};
    Assert.assertEquals(2, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {2}, Max.getMaxIndexValues(v));
  }
  
  @Test
  public void testDuplicateStartValues() {
    final int[] v = {40, 40, -0, 1, 7, 1, 12};
    Assert.assertEquals(0, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {0, 1}, Max.getMaxIndexValues(v));
  }
  
  @Test
  public void testDuplicateEndValues() {
    final int[] v = {-4, -4, 3, 7, 20, 20, 20};
    Assert.assertEquals(4, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {4, 5, 6}, Max.getMaxIndexValues(v));
  }
  
  @Test
  public void testDuplicateCenterValues() {
    final int[] v = {-4, -4, 3, 20, 20, 20, -6, 3};
    Assert.assertEquals(3, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {3, 4, 5}, Max.getMaxIndexValues(v));
  }
  
  @Test
  public void testMultipleGroupsValues() {
    final int[] v = {20, 20, -4, -4, 3, 20, 20, 20, -6, 3, 20, 20};
    Assert.assertEquals(0, Max.getFirstMaxIndex(v));
    Assert.assertArrayEquals(new int[] {0, 1, 5, 6, 7, 10, 11}, Max.getMaxIndexValues(v));
  }
}
