import java.awt.Color;

/**
 * A cell's state: Either alive or dead
 *
 */
public enum CellState {
  
  /**
   * Cell is alive.
   */
  living(Color.black, "Cell is in 'alive' state") ,
  /**
   * Cell is dead.
   */
  dead(Color.white, "Cell is in 'dead' state");

  /**
   * The cell's color when rendered.
   */
  public final Color color;

  private final String description;
  
  CellState(final Color color, final String description) {
    this.color = color;
    this.description = description;
  }

  @Override
  public String toString() {
    return description; 
  }
}
