import java.awt.Color;

/**
 * A cell's state: Either alive or dead
 *
 */
public enum CellState {
  /**
   * Cell is alive.
   */
  ALIVE(Color.black, "Cell is in 'alive' state") ,
  /**
   * Cell is dead.
   */
  DEAD(Color.white, "Cell is in 'dead' state");

  /**
   * The cell's color when rendered.
   */
  public final Color color;
  
  private final String description;
  private CellState inverseState;

  static {                      // "Class" constructor. You may want to read the
    ALIVE.inverseState = DEAD; // "Using Initialization Blocks" subsection within the 
    DEAD.inverseState = ALIVE; // "Initializing Data Members" section of Ivor Horton's
  }                             // Java introduction.
  
  CellState(final Color color, final String description) {
    this.color = color;
    this.description = description;
  }
  @Override
  public String toString() {
    return description; 
  }
  
  /**
   * @return {@link #ALIVE} if current value is {@link #DEAD},
   *  {@link #DEAD} if current value is {@link #ALIVE}
   */
  public CellState getInverseState() {
    return inverseState;
  }
}
