package de.hdm_stuttgart.de.sd1.rounding;

/**
 * Creating a math table providing sin values
 * in the range [0, 355] for every 5 degrees
 *
 */
public class MathTable {

  /**
   * @param args unused
   */
  public static void main(String[] args) {

    System.out.println("  x | sin(x)");
    System.out.println("----+------");
    for (int i = 0; i < 360; i += 5) {
      
      final double
        sinValue = Math.sin(i * Math.PI / 180); // Turning degrees into radians
      final long
        precision = 1000,// Rounding to three decimal places
        sinValueRounded = Math.round(precision *  sinValue), 
        digits = sinValueRounded / precision;
      
      long fraction = sinValueRounded % precision;
      
      if (i < 9) {  // index number right alignment
        System.out.print("  "); // One digit, add two spaces
      } else if (i < 99) {      
        System.out.print(" ");  // Two digits, add one space
      }
      
      if (fraction < 0) {
        fraction *= -1;
        System.out.print(i + " |-" + digits + ".");
      } else if (-1 < digits){
        System.out.print(i + " | " + digits + ".");
      } else {
        System.out.print(i + " |"  + digits + ".");
      }
      
      if (fraction < 9) { // Padding fraction with zeros if required
        System.out.print("00"); // One digit, add two leading zeros
      } else if (fraction < 99) {
        System.out.print("0"); // Two digits, add one leading zero
      } 
      
      System.out.println(fraction);
      
      if (0 < i && 0 == i % 20) { // Add extra seperator every four lines
        System.out.println("----+------");
      }
    }
  }
}
