package de.hdm_stuttgart.mi.sda1.jdom.common;

import java.io.PrintStream;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/**
 * Simple error handling for SAX Events.
 * 
 */
public class MySaxErrorHandler implements ErrorHandler {
   
   private PrintStream out; //The error handler's output goes here

   private String getParseExceptionInfo //Returns a string describing
   (SAXParseException ex) { //parse exception details.
     return "Error '" + ex.getMessage() + "' at line " + 
      ex.getLineNumber() + ", column " +
         ex.getColumnNumber();
   }

   /**
    * Error and warning messages may be written to selected output channels.
    * 
    * @param out The desired output channel.
    */
   public MySaxErrorHandler(final PrintStream out) {
     this.out = out;
   }
   @Override
   public void warning(SAXParseException exception) throws SAXException {
      out.print("Warning:" + getParseExceptionInfo(exception));
   }
   @Override
   public void error(SAXParseException exception) throws SAXException {
      out.print("Error:" + getParseExceptionInfo(exception));
   }
   @Override
   public void fatalError(SAXParseException exception) throws SAXException {
      out.print("Fatal error:" + getParseExceptionInfo(exception));
   }
}