package de.hdm_stuttgart.mi.sda1.saxhtml;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * Turning &lt;memo&gt; documents to html
 *
 */
public class Memo2HtmlHandler extends DefaultHandler {

  boolean printElementContent = false;

  @Override public void startDocument() throws SAXException {
    System.out.println("Opening document, change me to become a HTML producer");
  }

  @Override
  public void startElement(String uri, String localName, String tagName,
      Attributes attributes) throws SAXException {
    System.out.println("Opening element " + tagName + " , change me to become a HTML producer");
  }

  @Override
  public void characters(char[] ch, int start, int length) throws SAXException {
    final String elementContent = new String(ch, start, length).trim();
    if (!elementContent.equals("")) { // avoid white space
      System.out.println("Charcter content '" + elementContent + "', change me to become a HTML producer");
    }
  }
  
  @Override
  public void endElement(String uri, String localName, String tagName)
      throws SAXException {
    System.out.println("Closing element " + tagName + " , change me to become a HTML producer");
  }

  @Override public void endDocument() throws SAXException {
    System.out.println("closing document, change me to become a HTML producer");
  }
}