package de.hdm_stuttgart.mi.tools;

import com.vaadin.data.Validator;
import com.vaadin.ui.AbstractField;
import com.vaadin.ui.Field;

public class ValidateSecondIdenticalInput implements Validator {
	
	private static final long serialVersionUID = -3334158348944078195L;
	final Field<?> reference;
	
	public ValidateSecondIdenticalInput(final Field<?> reference) {
		this.reference = reference;
	}

	@Override
	public void validate(Object value) throws InvalidValueException {
		
		if (null != value &&  ! (value instanceof String)) {
			throw new InvalidValueException("Field is not of string type");
		} else if (null != reference.getValue() &&  ! (reference.getValue() instanceof String)) {
			throw new InvalidValueException("Comparison field is not of string type");
		} else {
			final String stringValue, referenceStringValue;
			if (null == value) {
				stringValue = "";
			} else {
				stringValue = ((String) value);
			}
			
			if (null == reference.getValue()) {
				referenceStringValue = "";
			} else {
				referenceStringValue = ((String) reference.getValue());
			}
			
			if (!referenceStringValue.equals("") && ! stringValue.equals(referenceStringValue)) {
				throw new InvalidValueException("Passwords do not match");
			} else {
				((AbstractField<?>)reference).setComponentError(null);
			}
		}
	}
}
