package de.hdm_stuttgart.mi.sda2.forum.tools;

import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import de.hdm_stuttgart.mi.sda2.forum.domain.User;
import de.hdm_stuttgart.mi.sda2.forum.domain.User_;


public class Credential {

	private static EntityManager em = PersistenceHelper.getEntityManager();
	
	public static User check(final String email, final String cleartextPassword) {

		final CriteriaBuilder critBuilder = em.getCriteriaBuilder();
		
		final CriteriaQuery<User> userQuery = critBuilder.createQuery(User.class);
		final Root<User> userRoot = userQuery.from(User.class);
		final Predicate matchingEmail = critBuilder.equal(userRoot.get(User_.email), email);
		userQuery.where(matchingEmail);
		
		final List<User> result = em.createQuery(userQuery).getResultList();
		if (1 == result.size()) {
			final User user = result.get(0);
			if (HashProvider.check(cleartextPassword.toCharArray(), user.getPassword())) {
				return user;
			} else {
				em.detach(user);
			}
		}
		return null;
	}
}
