package de.hdm_stuttgart.mi.codeformat;

import java.io.PrintStream;

import org.w3c.dom.DOMError;
import org.w3c.dom.DOMErrorHandler;

/**
 * @author $Author$
 * @version $Rev$ $Date$
 *
 * $URL$.
 *
 */
public class DomErrorHandler implements DOMErrorHandler {
  public boolean handleError(DOMError error) {
    out.print(getParseExceptionInfo(error));
    switch(error.getSeverity()){
    case org.w3c.dom.DOMError.SEVERITY_FATAL_ERROR: return false;
      default: return true;
    }
  }
  /**
   * @param out Error messages will go here.
   */
  public DomErrorHandler(final PrintStream out) {
    this.out = out;
  }
  private String getParseExceptionInfo //Returns a string describing
  (DOMError error) { //parse exception details.
    return "Error '" + error.getMessage() + "' at line " + 
     error.getLocation().getLineNumber() + ", column " +
        error.getLocation().getColumnNumber();
  }
  private PrintStream out; //The error handler's output goes here
}
