<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
    xmlns:db="http://docbook.org/ns/docbook"
    xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns="http://docbook.org/ns/docbook">
    
    <xsl:variable name="generateIdPrefix">__sdwordm4342cs__</xsl:variable>
    
    <xsl:output indent="no"/>

    <xsl:template match="@* | node()">
        <xsl:copy>
            <xsl:apply-templates select="@* | node()"/>
        </xsl:copy>
    </xsl:template>


    <xsl:template match="/">
        <section version="5.0" xml:id="someValue"
            xmlns="http://docbook.org/ns/docbook"
            xmlns:xlink="http://www.w3.org/1999/xlink"
            xmlns:xi="http://www.w3.org/2001/XInclude"
            xmlns:svg="http://www.w3.org/2000/svg"
            xmlns:m="http://www.w3.org/1998/Math/MathML"
            xmlns:html="http://www.w3.org/1999/xhtml"
            xmlns:db="http://docbook.org/ns/docbook">
            <title>Extracted Figures</title>
            
            <para>Extracted Figures</para>
            <xsl:apply-templates select="//db:figure[db:mediaobject/db:imageobject]" mode="count"/>
            
        </section>
    </xsl:template>
    
    <xsl:template match="db:figure[db:mediaobject/db:imageobject]" mode="count">
        
        <section xml:id="sec_{@xml:id}">
            <title>
                <xsl:value-of select="position()"/>
                <xsl:text>:</xsl:text>
                <xsl:value-of select="db:mediaobject/db:imageobject/db:imagedata/@fileref"/>
            </title>
            
            <xsl:apply-templates select="."/>
        </section>
    </xsl:template>
    
    
    <xsl:template match="db:xref">
        <db:emphasis>
            <xsl:text>XREF </xsl:text>
            <xsl:value-of select="@linkend"/>
            <xsl:text> replaced</xsl:text>
            
        </db:emphasis>
    </xsl:template>
    


</xsl:stylesheet>
