package component.address;



import hibintro.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.cfg.DefaultComponentSafeNamingStrategy;

/**
 * @author goik
 * 
 * Modify embedded content in a persistent {@link User} instance.
 *
 */
public class ModifyWorkAddress {
  static {
    HibernateUtil.configuration.setNamingStrategy(new DefaultComponentSafeNamingStrategy());
  }

   /**
    * Retrieving a single {@link User} instance by means
    * of its primary key value two times in succession.
    * @param args unused
    */
   public static void main(String[] args) {

      {
         final Session session = HibernateUtil.createSessionFactory("component/address/hibernate.cfg.xml").openSession();
         final Transaction transaction = session.beginTransaction();
         final User user = (User) session.load(User.class, 1L);

         user.getWorkAddress().setStreet("100 Baker St");
         
         transaction.commit();
         session.close();
      }
   }
}