package component.address;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.hibernate.cfg.DefaultComponentSafeNamingStrategy;

/**
 * @author goik
 * 
 * Persisting {@link User} instances having component E-Mail Addresses
 *
 */
public class PersistUser {
  
  static {
    HibernateUtil.configuration.setNamingStrategy(new DefaultComponentSafeNamingStrategy());
  }
   /**
    * @param args not used.
    */
   public static void main(String[] args) {
     
      final Session session = HibernateUtil.createSessionFactory("component/address/hibernate.cfg.xml").openSession();

      final Transaction transaction = session.beginTransaction();
      {
         final User u = new User(123, "goik", "Martin Goik");
         u.setHomeAddress(new Address("144 Kings Highway", "S.W. Dover", "DE 19901"));
         u.setWorkAddress(new Address("22 Baker St", "Morton", "PA 19070"));
         session.save(u);
      }
      transaction.commit();
   }
}