package component.emails;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * @author goik
 * 
 * Persisting {@link User} instances having component E-Mail Addresses
 *
 */
public class PersistUser {

   /**
    * @param args not used.
    */
   public static void main(String[] args) {
      final Session session = HibernateUtil.createSessionFactory("component/emails/hibernate.cfg.xml").openSession();

      {
        final Transaction transaction = session.beginTransaction();
         final User u = new User(123, "goik", "Martin Goik");
         u.getEmails().add(new Email("goik@hdm-stuttgart.de"));
         u.getEmails().add(new Email("goma@someserver.org"));
         session.save(u);
         transaction.commit();
      }
   }
}