package entity.company1;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 * 
 * Laptops possibly being assigned to {@link Employee}   
 * 
 */
@Entity
@Table(uniqueConstraints={@UniqueConstraint(columnNames={"idNumber"})})
public class Laptop {

  @Id
  @GeneratedValue
  public Long getId() {return id;}
  protected void setId(Long id) {this.id = id;}
  private Long id;

  /**
   * @return The device's unique part number
   */
  public int getIdNumber() { return idNumber;}
  public void setIdNumber(int idNumber) { this.idNumber = idNumber;}
  int idNumber;
  
  protected Laptop(){}
  
  public Laptop(final int idNumber) {
    setIdNumber(idNumber);
  }
  @Override
  public boolean equals(Object other) {
    if (this == other) {
      return true;
    } else if (Integer.MIN_VALUE == getIdNumber()) {
      return false;
    } else if (other instanceof Laptop) {
      final Laptop that = (Laptop) other;
      return this.getIdNumber() == that.getIdNumber();
    } else {
      return false;
    }
  }
  @Override
  public int hashCode() {
    if (Integer.MIN_VALUE == getIdNumber()) {
      return System.identityHashCode(this);
    } else {
      return getIdNumber();
    }
  }
}