package entity.company1;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * @author goik
 * 
 * Persisting {@link Employee} possibly along with
 * personally assigned laptops. Persisting dependent
 * transient objects corrects bug in {@link Persist1} 
 *
 */
public class Persist2 {

  /**
   * @param args not used.
   */
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("entity/company1/hibernate.cfg.xml").openSession();

    {
      final Transaction transaction = session.beginTransaction();
      final Employee  martin = new Employee(123, "Martin Goik"),
                      eve = new Employee(140, "Eve Blix");
      
      final Laptop superCoolGadget = new Laptop(2213);
      eve.setLaptop(superCoolGadget);
      session.save(martin);
      session.save(eve);

      session.save(superCoolGadget);

      transaction.commit();
    }
  }
}