package entity.company2;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * Persisting {@link Employee} possibly along with
 * personal assigned laptops.
 */
public class Persist {
  /**
   * @param args not used.
   */
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("entity/company2/hibernate.cfg.xml").openSession();
    {
      final Transaction transaction = session.beginTransaction();
      final Employee  martin = new Employee(123, "Martin Goik"),
                      eve = new Employee(140, "Eve Blix");
      
      final Laptop superCoolGadget = new Laptop(2213);
      eve.setLaptop(superCoolGadget);
      // Now only save the employee transients,
      // superCoolGadget will be saved automatically due to
      // CascadeType.ALL 
      session.save(martin);
      session.save(eve);
      transaction.commit();
    }
  }
}