package entity.company6;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

import entity.company6.model.Employee;
import entity.company6.model.Laptop;

/**
 * Removing {@link Laptop} from {@link Employee} 
 */
public class ExchangeLaptops {
  /**
   * @param args not used.
   */
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("entity/company6/hibernate.cfg.xml").openSession();
    {
      final Transaction transaction = session.beginTransaction();
      final Employee martin = (Employee) session.load(Employee.class, 1L),
          eve = (Employee) session.load(Employee.class, 2L);
      
      final Laptop currentMartin2214 = (Laptop) session.load(Laptop.class, 1L),
          currentEve2213 = (Laptop) session.load(Laptop.class, 2L);
      
      eve.setLaptop(currentMartin2214);
      currentEve2213.setOwner(martin);
      
      System.out.println("Martin:" + martin.getLaptop().getId());
      System.out.println("Eve:" + eve.getLaptop().getId());
      
      System.out.println("currentEve2213:" + currentEve2213.getOwner().getCname());
      System.out.println("currentMartin2214:" + currentMartin2214.getOwner().getCname());

      transaction.commit();
    }
  }
}