package entity.company6;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

import entity.company6.model.Employee;
import entity.company6.model.Laptop;

public class Persist {
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("entity/company6/hibernate.cfg.xml").openSession();
    {
      final Transaction transaction = session.beginTransaction();
      final Employee  martin = new Employee(123, "Martin Goik"),
          eve = new Employee(140, "Eve Blix");

      final Laptop superCoolGadget = new Laptop(2213),
          g2 = new Laptop(2214),
          g3 = new Laptop(2215); // Not being referenced later

      martin.setLaptop(g2);
      eve.setLaptop(superCoolGadget);
      // Now only save the employee transients,
      // superCoolGadget will be saved automatically due to
      // CascadeType.ALL 
      session.save(martin);
      session.save(eve);
      session.save(g3);
      transaction.commit();
    }
  }
}