package entity.company8;

import hibintro.util.HibernateUtil;

import org.hibernate.Session;
import org.hibernate.Transaction;

import entity.company8.model.Employee;
import entity.company8.model.Project;




/**
 * Defining many-to-many relationship between
 * {@link Employee} and {@link Project}
 *
 */
public class Persist {
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("entity/company8/hibernate.cfg.xml").openSession();
    {
      final Transaction transaction = session.beginTransaction();
      final Employee  martin = new Employee(123, "Martin Goik"),
          eve = new Employee(140, "Eve Blix"),
          jim = new Employee(160, "Jim Clarke");
      
      session.save(martin);
      session.save(eve);
      session.save(jim);

      final Project water = new Project(1, "Water supply")
      ,health = new Project(2, "Health management");
 
      water.addEmployee(martin);
      water.addEmployee(eve);
      session.save(water);
      session.save(health);
      
      
      transaction.commit();
    }
  }
}