package hibintro.v1.run;



import hibintro.util.HibernateUtil;
import hibintro.v1.model.User;

import org.hibernate.Session;
import org.hibernate.Transaction;



/**
 * @author goik
 * 
 * Retrieval of a single {@link User} object from a database.
 *
 */
public class RetrieveSingleUser {

  /**
   * Retrieving a single {@link User} instance by means
   * of its primary key value "goik".
   * @param args unused
   */
  public static void main(String[] args) {
    final Session session = HibernateUtil.createSessionFactory("hibernate.cfg.xml").openSession();

    final Transaction transaction = session.beginTransaction();

    final User u = (User) session.load(User.class, "goik");
    if (null == u ) {
      System.out.println("No such user 'goik'");
    } else {
      System.out.println("Found user '" + u.getCname() + "'");
    }
    transaction.commit();
  }
}