package hibintro.v9;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;

import org.hibernate.annotations.Type;

/**
 * @author goik
 * 
 *         {@link User} instances with re-mapped boolean property
 */
@Entity
public class User {

   int uidNumber;
   @Id
   public int getUidNumber() {return uidNumber;}
   public void setUidNumber(int uidNumber) {this.uidNumber = uidNumber;}

   String uid;
   /**
    * @return The user's unique login name e.g. "goik"
    */
   @Column(nullable=false)
   public String getUid() {return uid;}
   /**
    * @param uid See {@link #getUid()}.
    */
   public void setUid(String uid) {this.uid = uid;}

   String cname;
   /**
    * @return The user's common name e.g. "Martin Goik"
    */
   public String getCname() {return cname;}
   /**
    * @param cname See {@link #getCname()}.
    */
   public void setCname(String cname) {this.cname = cname;}

   boolean active = false;
   @Type(type="yes_no")
   public boolean isActive() {return active;}
   public void setActive(boolean active) {this.active = active;}
}