package inherit.joined.v2;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

/**
 * @author goik
 * 
 *   Root class implementing figure elements
 */
@Entity
@Inheritance(strategy=InheritanceType.JOINED)
public abstract class Figure {
   
   private Long id;
   @Id
   @GeneratedValue
   public Long getId() {return id;}
   protected void setId(Long id) {this.id = id;}
   
   private double xCoord;
   /**
    * @return May be credit card or bank account number
    */
   @Column(nullable = false)
   public final double getXccord() {return xCoord;}
   public final void setXccord(double xCoord) {this.xCoord = xCoord;}

   private double yCoord;
   @Column(nullable = false)
   public double getYCoord() {return yCoord;}
   public void setYCoord(double yCoord) {this.yCoord = yCoord;}
   
   protected Figure() {}
   public Figure(final double xCoord, final double yCoord) {
      setXccord(xCoord);
      setYCoord(yCoord);
   }
   @Override
   public String toString() {
      return getClass().getSimpleName() + ": x=" + getXccord() + 
               ", y= " + getYCoord();
   }
}