package session2;

import hibintro.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * @author goik
 * 
 * Comparing newly created {@link User} instances both with persistent
 * and transient partners.
 *
 */
public class CompareNewlyCreated {

  public static void main(String[] args) {

    // Create two transient instances
    final User a = new User(123, "goik", "Martin Goik"),
        b = new User(123, "goik", "Martin Goik");

    System.out.println("a.equals(b):" + a.equals(b));

    {
      final Session session = HibernateUtil.createSessionFactory("session2/hibernate.cfg.xml").openSession();
      final Transaction transaction = session.beginTransaction();
      
      // previously saved as  new User(123, "goik", "Martin Goik");
      final User user = (User) session.load(User.class, 1L);

      System.out.println("a.equals(user)):" + a.equals(user));

      transaction.commit();
      session.close();
    }
  }
}