package session3;



import hibintro.util.HibernateUtil;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 * @author goik
 * 
 * Repeated retrieval of a single {@link User} object from a database.
 *
 */
public class LoadUser {

   /**
    * Retrieving a single {@link User} instance by means
    * of its primary key value two times in succession.
    * @param args unused
    */
   public static void main(String[] args) {

      final User user;
      {
         final Session session = HibernateUtil.createSessionFactory("session3/hibernate.cfg.xml").openSession();
         final Transaction transaction = session.beginTransaction();
         user = (User) session.load(User.class, 1L);
         final User user1 = (User) session.load(User.class, 1L);

         System.out.println(" first transaction: user.equals(user1):" + user.equals(user1));

         transaction.commit();
         session.close();
      }
      {
         final Session session = HibernateUtil.createSessionFactory("session3/hibernate.cfg.xml").openSession();
         final Transaction transaction = session.beginTransaction();
         final User user2 = (User) session.load(User.class, 1L);

         boolean val = user.equals(user2);
         System.out.println("second transaction: user.equals(user2):" + val);

         transaction.commit();
         session.close();
      }
   }
}