<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: book2html.xsl 177 2006-11-01 16:36:30Z goik $ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  
  <xsl:output
    doctype-public="-//W3C//DTD XHTML 1.0 Strict//EN"
    doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd" 
    method="xml" indent="yes"/>
  
  <xsl:template match="/book">
    <xsl:variable name="pageTitle" select="title"/>
    <html>
      <head>
        <title><xsl:value-of select="$pageTitle"/></title>
      </head>
      <body>
        <h1><xsl:value-of select="$pageTitle"/></h1>
        <xsl:apply-templates select="chapter"/>
      </body>
    </html>
  </xsl:template>
  
  <xsl:template match="chapter">
    <!-- Show the chapter's title -->
    <h2><xsl:value-of select="title"/></h2>
    <!-- Process all para elements below this chapter -->
    <xsl:apply-templates select="para"/>
  </xsl:template>
  
  <xsl:template match="para">
    <!--The dot (.) denotes the content of the current para element-->
    <p><xsl:value-of select="."/></p>
  </xsl:template>
  
</xsl:stylesheet>