package dom.xpath;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

/** Check Readability of a given URL
 * @author $Author: goik $
 * @version $Rev: 290 $ $Date: 2007-11-19 17:49:15 +0100 (Mo, 19. Nov 2007) $
 *
 * $URL: https://version.mi.hdm-stuttgart.de/svn/goikvorles/trunk/Vorlesungen/WEB-INF/src/dom/xpath/CheckUrl.java $.
 *
 */
public class CheckUrl {
  /** Check whether a given object like http://someserver.com/img.gif
   *  can be retrieved.
   * @param urlRef
   *  The URL to be checked for read access
   */
  public static void checkReadability(final String urlRef) {
    try {
      final URL url = new URL(urlRef);
      try {
        final Object imgCandidate = url.getContent();
        if (null == imgCandidate) {
          System.err.println("Unable to open '" + urlRef + "'");
        } else {
          System.out.println("Received '"
              + imgCandidate.getClass().getName() + "' from "
              + urlRef);
        }
      } catch (IOException e) {
        System.err.println("Unable to open '" + urlRef + "'");
      }
    } catch (MalformedURLException e) {
      System.err.println("Adress '" + urlRef + "' is malformed");
    }
  }
}