package sax.context;

import java.io.IOException;

import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

import dom.MySaxErrorHandler;

/** Parsing catalog instances for import to RDBMS. */
public class Catalog2Sql {
  
  /** Set up a validating parser instance.
   * 
   * @throws SAXException Parsing may fail.
   * @throws ParserConfigurationException Unable to instantiate parser.
   */
  public Catalog2Sql()
  
   throws SAXException, ParserConfigurationException {
      final SAXParserFactory saxPf = SAXParserFactory.newInstance();
      final SAXParser saxParser = saxPf.newSAXParser();
      xmlReader = saxParser.getXMLReader();
      xmlReader.setFeature("http://xml.org/sax/features/validation", true);
      xmlReader.setContentHandler(new ImportHandler());
      xmlReader.setErrorHandler(new MySaxErrorHandler(System.out));
  }
  /** Initiate parsing
   * @param uri The resource to be parsed
   * @throws IOException file access problem
   * @throws SAXException Parsing may fail.
   */
  public void parse(final String uri) 
    throws IOException, SAXException{
    xmlReader.parse(uri);
  }
  private final XMLReader xmlReader;
}