package sax.rdbms;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
import dom.xsl.DbAccess;

/**
 * @author $Author: goik $
 * @version $Rev: 299 $ $Date: 2007-12-04 16:09:56 +0100 (Di, 04. Dez 2007) $
 *
 * $URL: https://version.mi.hdm-stuttgart.de/svn/goikvorles/trunk/Vorlesungen/WEB-INF/src/sax/rdbms/HtmlEventHandler.java $.
 *
 */
public class HtmlEventHandler extends DefaultHandler{
  public void startDocument() {
    dbaccess.connect("jdbc:mysql://localhost:3306/hdm",
        "hdmuser", "XYZ");
    System.out.println("<html><head><title>Catalog</title></head>");
  }
  public void endDocument() {
    System.out.println("</html>");
    dbaccess.close();
  }
  public void startElement(String namespaceUri, String localName,
      String rawName, Attributes attrs){
    if (rawName.equals("catalog")){
      System.out.println("<body><H1>A catalog</H1>"
          +"<table border='1'><tbody>");
      System.out.println("<tr><th>Order number</th>\n"
          + "<th>Price</th>\n"
          +" <th>Product</th></tr>");
    } else if (rawName.equals("item")){
      final String orderNo = attrs.getValue("orderNo");
      System.out.print("<tr><td>" + orderNo 
          	+ "</td>\n<td>" + dbaccess.readPrice(orderNo)
          	+ "</td>\n<td>");
    } else {
      System.err.println("Element '" + rawName + "' unknown");
    }
  }
  public void endElement(String namespaceUri, String localName,
      String rawName) {
    if (rawName.equals("catalog")){
      System.out.println("</tbody></table>");     
    } else if (rawName.equals("item")){
      System.out.println("</td></tr>\n");
    } 
  }
  public void characters(char[] ch, int start, int length) {
    System.out.print(new String(ch, start, length));
  }
  private DbAccess dbaccess = new DbAccess();
}