package sda.jdbc.intro.auth;

import javax.swing.JComponent;
import javax.swing.JTextField;

/**
 * This validator class checks for two fields having identical value.
 * Verifying two password values to be identical (user registration)
 * is a typical use case.
 * 
 * @author goik
 */
public class EqualValueVerifier extends InputVerifierNotify {

   final JTextField compare;
   /**
    * For each input field to be validated we need the
    * following parameters:
    * 
    * @param field The first input field
    * @param compare The second input field
    * @param errMsg  This text will be presented to the user in case the input field values differ
    */
   public EqualValueVerifier (final JTextField field, JTextField compare, final String errMsg) {
      super(field, errMsg);
      this.compare = compare;
   }

   @Override
   public boolean verify(JComponent input) {
      if (input instanceof JTextField) {
         if (((JTextField) input).getText().equals(compare.getText())) {
            validationLabel.setText("");
            return true;
         } else {
            validationLabel.setText(errorMessage);
         }
      }
      return false;
   }
}