package sda.jdbc.intro.v01;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class InsertPerson extends JFrame {

   private static final long serialVersionUID = -5427181942099955412L;

   public static void main(String[] args) throws SQLException {
      InsertPerson app = new InsertPerson();
      app.setVisible(true);
   }

   public InsertPerson () throws SQLException{
      super ("Add a person's data");

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      final JPanel databaseFieldPanel = new JPanel();
      databaseFieldPanel.setLayout(new GridLayout(0,2));
      add(databaseFieldPanel, BorderLayout.CENTER);

      databaseFieldPanel.add(new JLabel("Name:"));
      final JTextField nameField = new JTextField(15);
      databaseFieldPanel.add(nameField);

      databaseFieldPanel.add(new JLabel("E-mail:"));
      final JTextField emailField = new JTextField(15);
      databaseFieldPanel.add(emailField);

      final JButton insertButton = new JButton("Insert");
      add(insertButton, BorderLayout.SOUTH);

      final Connection conn = DriverManager.getConnection(
            "jdbc:mysql://localhost:3306/hdm", "hdmuser", "XYZ");
      final Statement stmt = conn.createStatement();

      insertButton.addActionListener(new ActionListener() {
         // Linking the GUI to the database server. We assume an open
         // connection and a correctly initialized Statement instance
         @Override
         public void actionPerformed(ActionEvent event) {
            final String sql = "INSERT INTO Person VALUES('" + nameField.getText()+ "', '" 
                  + emailField.getText() +  "')";
            // We have to catch this Exception because an ActionListener's signature
            // prohibits the existence of a "throws" clause.
            try {
               final int updateCount = stmt.executeUpdate(sql);
               JOptionPane.showMessageDialog(null, "Successfully executed \n'" + sql + "'\nand inserted "
                     + updateCount + " dataset");
            } catch (SQLException e) {
               e.printStackTrace();
            }
         }
      });
      pack();
   }
}
