package sda.regexp;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * This class is intended to gain some basic experience with
 * regular expressions and their usage in Java
 * 
 * @author goik
 *
 */
public class RegexpPrimer {

   
   public static void main(String[] args) {
      final String [] wordList = new String [] {"Eric", "126653BBb", "_login","some text"};
      final String [] regexpList = new String[] {"[A-K].*", "[^0-9]+.*", "_[a-z]+", ""};
      
      for (final String word: wordList) {
         for (final String regexp: regexpList) {
            testMatch(word, regexp);
         }
      }
   }
   
   /**
    * Matching a given word by a regular expression. A log message is being
    * written to stdout.
    * 
    * Hint: The implementation is based on the explanation being given in the
    * introduction to {@link Pattern}
    * 
    * @param word This string will be matched by the subsequent argument.
    * @param regexp The regular expression tested to match the previous argument.
    * @return true if regexp matches word, false otherwise.
    */
   public static boolean testMatch(final String word, final String regexp) {
      Pattern p = Pattern.compile(regexp);
      Matcher m = p.matcher(word);
      if (m.matches()) {
         System.out.println("The expression '" + regexp + "' matches '" + word + "'");
         return true;
      } else {
         System.out.println("The expression '" + regexp + "' does not match '" + word + "'");
         return false;
      }
   }
}
