package step2;

/**
 * A circle of given radius
 *
 */
public class Circle {

  double x, y, radius;

  /**
   * A new circle
   * @param radius The desired radius.
   */
  public Circle(int x, int y, double radius) {
    setRadius(radius);
  }

  /**
   * @return The circle's area.
   */
  public double getArea() {
    return radius * radius * Math.PI;
  }

  /**
   * @return The circle's perimeter.
   */
  public double getPerimeter() {
    return 2 * Math.PI * radius;
  }

  /**
   * @return The circle's radius.
   */
  public double getRadius() {
    return radius;
  }

  /**
   * @param radius Setting the circle's radius to a new value.
   */
  public void setRadius(double radius) {
    this.radius = radius;
  }
  
  /**
   * @param x The circle's x center coordinate value
   */
  public void setX(double x) {
    this.x = x;
  }
  /**
   * @param x The circle's x center coordinate value
   */
  public void setY(double y) {
    this.y = y;
  }
  
public void writeSvg() {
  final int scale = 20;

    System.out.println( 
        "<circle r='" + scale * radius + 
        "' cx='" + scale * x + "'" + " cy='" + scale * y + 
        "' style='fill:rgb(0,0,255);stroke-width:3;stroke:rgb(0,0,0)'/>");
    
  }
  
}